#include <bits/stdc++.h>
using namespace std;

const int MAXN = 100001;
int n, m;
vector<int> v[MAXN];
bool us1[MAXN], Found;
bool fl[MAXN];
int t[MAXN], f[MAXN];
int br;
set<pair<int, int>> most;

void dfs(int vr, int pr) {
    fl[vr] = 1;
    br++;  t[vr] = br;  f[vr] = br;
    for(int i=0;i<v[vr].size();i++){
        int to = v[vr][i];
        if(to == pr) continue;
        if(fl[to]) f[vr] = min(f[vr], t[to]);
        else {
            dfs(to, vr);
            f[vr] = min(f[vr], f[to]);
            if(f[to] > t[vr]) most.insert({to, vr});
        }
    }
}


void Rec1(int tek, int y, int a, int b) {
    if(tek == y) Found = true;
    if(Found) return;
    if(us1[tek]) return;
    us1[tek] = true;
    for(int i=0;i<v[tek].size();i++) {
        int to = v[tek][i];
        if(tek == a && to == b) continue;
        if(tek == b && to == a) continue;
        Rec1(to, y, a, b);
    }
}

void Rec2(int tek, int y, int a) {
    if(tek == y) Found = true;
    if(Found) return;
    if(us1[tek]) return;
    us1[tek] = true;
    for(int i=0;i<v[tek].size();i++) {
        int to = v[tek][i];
        if(to == a) continue;
        Rec2(to, y, a);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    int i;
    for(i=1;i<=m;i++) {
        int p, q;
        cin>>p>>q;
        v[p].push_back(q);
        v[q].push_back(p);
    }
    dfs(1, -1);
    for(set<pair<int,int>>::iterator it = most.begin(); it != most.end(); ++it)
        cout<<it->first<<" "<<it->second<<endl;
    int q;
    cin>>q;
    while(q--) {
        int z, x, y, a, b;
        cin>>z;
        if(z == 1) {
            cin>>x>>y>>a>>b;
            if(most.find({a,b}) == most.end() &&
               most.find({b,a}) == most.end()) {
                    cout<<"yes"<<endl;
                    continue;
            }
            fill(us1+1, us1+n+1, 0);
            Found = false;
            Rec1(x, y, a, b);
            if(Found) cout<<"yes"<<endl;
            else  cout<<"no"<<endl;
        }
        else
        if(z == 2) {
            cin>>x>>y>>a;
            fill(us1+1, us1+n+1, 0);
            Found = false;
            Rec2(x, y, a);
            if(Found) cout<<"yes"<<endl;
            else  cout<<"no"<<endl;
        }
    }



    return 0;
}

