#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

int const MAXN=1000000;
int n, m, q, used[MAXN];
vector<int> v[MAXN];

bool BFS(int i, int u)
{
    used[i] = 1;
    queue<int> q;
    q.push(i);
    while(!q.empty())
    {
        int w = q.front();
        q.pop();
        int sz = v[w].size();
        for(int j=0;j<sz;j++)
        {
            int nb = v[w][j];
            if(!used[nb])
            {
                used[nb] = 1;
                if(nb == u) return true;
                q.push(nb);
            }
        }
    }
    return false;
}

bool BFS1(int i, int u, int a, int b)
{
    used[i] = 1;
    queue<int> q;
    q.push(i);
    while(!q.empty())
    {
        int w = q.front();
        q.pop();
        int sz = v[w].size();
        for(int j=0;j<sz;j++)
        {
            int nb = v[w][j];
            if((w == a && nb == b) ||(w == b && nb == a)) ;
            else if(!used[nb])
            {
                used[nb] = 1;
                if(nb == u) return true;
                q.push(nb);
            }
        }
    }
    return false;
}

void read()
{
    int x, y, type, a, b;
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    cin>>q;
    for(int i=1;i<=q;i++)
    {
        cin>>type;
        if(type == 1)
        {
            cin>>x>>y>>a>>b;
            memset(used, 0, sizeof(used));
            if(BFS1(x, y, a, b)) cout<<"yes"<<endl;
            else cout<<"no"<<endl;
        }
        else
        {
            cin>>x>>y>>a;
            memset(used, 0, sizeof(used));
            used[a] = 1;
            if(BFS(x, y)) cout<<"yes"<<endl;
            else cout<<"no"<<endl;
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
