#include<bits/stdc++.h>
using namespace std;
const long long maxn = 100001;
long long n;
long long a[maxn];
long long tree[maxn*4];
long long max_num = 0;
long long mod = 998244353;
map< long long, long long>mp;
void update( long long i, long long l, long long r, long long pos, long long x )
{
    if( l == r )
    {
        tree[i] += x;
        if( tree[i] >=  mod ) tree[i] -= mod;
        return;
    }
    long long m = ( l + r ) /2;
    if( pos <= m ) update(i*2,l,m,pos,x);
    else update(i*2+1,m+1,r,pos,x);
    tree[i] = tree[i*2] + tree[i*2+1];
    if( tree[i] >= mod ) tree[i] -= mod;
}
long long query( long long i, long long l, long long r, long long ql, long long qr )
{
    if( ql == l && qr == r ) return tree[i];
    long long m = ( l + r ) / 2;
    if( qr <= m ) return query(i*2,l,m,ql,qr);
    else if( ql > m ) return query(i*2+1,m+1,r,ql,qr);
    else
    {
        long long x = query(i*2,l,m,ql,m);
        long long y = query(i*2+1,m+1,r,m+1,qr);
        long long z = x + y;
        if( z >= mod ) z -= mod;
        return z;
    }
}
void read()
{
    cin >> n;
    for( long long i = 1; i <= n; i ++ )
    {
        cin >> a[i];
        if( mp[a[i]] == 0 ) mp[a[i]] = 1;
    }
    long long cnt = 1;
    for( map<long long,long long>::iterator it = mp.begin(); it != mp.end(); it ++ )
    {
        pair<long long, long long>p = * it;
        long long nb = p.first;
        mp[nb] = cnt;
        cnt += 1;
    }

    for( long long i = 1; i <= n; i ++ )
    {
        a[i] = mp[a[i]];
        max_num = max( max_num , a[i] );
    }
}
void solve()
{
    for( long long i = n; i >= 1; i -- )
    {
        long long nb = a[i];
        long long t_dp = 1 + query(1,1,max_num,nb,max_num);
        if( t_dp >= mod ) t_dp -= mod;
        update(1,1,max_num,nb,t_dp);
    }
    cout << query(1,1,max_num,1,max_num) << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    solve();
    return 0;
}
