#include<bits/stdc++.h>
using namespace std;
const int maxn = 500000;
int n,m,q;
vector<int>v[maxn];
int art[maxn];
map< pair<int,int>, int>mp;
int used_art[maxn];
int used_edge[maxn];
void read()
{
    cin >> n >> m;
    for( int i = 1; i <= m; i ++ )
    {
        int x,y;
        cin  >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}
void dfs_art( int w , int x )
{
    used_art[w] = x;
    int sz = v[w].size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        if( used_art[nb] == 0 && art[nb] == 0 )
        {
            dfs_art(nb,x);
        }
    }
}
void dfs_edge( int w, int x )
{
    //cout << w << " " << x << endl;
    used_edge[w] = x;
    int sz = v[w].size();
    for( int i = 0; i < sz; i ++ )
    {
        int nb = v[w][i];
        pair<int,int>p(w,nb);
        if( used_edge[nb] == 0 && mp[p] == 0 )
        {
            dfs_edge(nb,x);
        }
    }
}
void query()
{
    cin >> q;
    for( int i = 1; i <= q; i ++ )
    {
        int type;
        cin >> type;
        if( type == 1 )
        {
            int x,y,z,c;
            cin >> x >> y >> z >> c;
            pair<int,int>p1(z,c);
            pair<int,int>p2(c,z);
            memset(used_edge,0,sizeof(used_edge));
            mp[p1] = 1;
            mp[p2] = 1;
            int br = 1;
            for( int j = 1; j <= n; j ++ )
            {
                if( used_edge[j] == 0 )
                {
                    dfs_edge(j,br);
                    br += 1;
                }
            }
            //cout << used_edge[x] << " " << used_edge[y] << endl;
            if( used_edge[x] == used_edge[y] ) cout << "yes" << endl;
            else cout << "no" << endl;
            mp[p1] = 0;
            mp[p2] = 0;

            cout << endl;
        }
        else
        {
            int x,y,z;
            cin >> x >> y >> z;
            art[z] = 1;
            int br = 1;
            for( int j = 1; j <= n; j ++ )
            {
                if( used_art[j] == 0 && art[j] == 0 )
                {
                    dfs_art(j,br);
                    br += 1;
                }
            }
            if( used_art[x] == used_art[y] ) cout << "yes" << endl;
            else cout << "no" << endl;
            br += 1;
            memset(used_art,0,sizeof(used_art));
            art[z] = 0;
        }
    }
}
int main()
{
    read();
    query();
    return 0;
}
