#include<bits/stdc++.h>
using namespace std;
const long long maxn = 500000;
long long n,m,v;
long long ans[maxn];
long long used[maxn];
long long wall[maxn];
long long tree[maxn*4];
long long inf = 100000000;
void make_tree( long long i, long long l, long long r )
{
    if( l == r)
    {
        long long tw1 = l;
        long long tw2 = l + 1;
        if( l == n ) tw2 = 1;

        wall[l] = ans[tw1] + ans[tw2];
        //cout << l << " " << wall[l] << endl;
        if( used[tw1] == 1 &&  used[tw2] == 1 ) wall[l] = inf;
        tree[i] = l;
        return;
    }
    long long m = ( l + r ) / 2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);

    if( wall[tree[i*2]] < wall[tree[i*2+1]] ) tree[i] = tree[i*2];
    else tree[i] = tree[i*2+1];
}
void update( long long i, long long l, long long r, long long pos )
{
    if( l == r )
    {
        wall[l] += 1;
        return;
    }
    long long m = ( l + r ) /2;
    if( pos <= m ) update(i*2,l,m,pos);
    else update(i*2+1,m+1,r,pos);

    if( wall[tree[i*2]] < wall[tree[i*2+1]] ) tree[i] = tree[i*2];
    else tree[i] = tree[i*2+1];
}
void read()
{
    cin >> n >> m >> v;
    for( long long i = 1; i <= m; i ++ )
    {
        long long pos,br;
        cin >> pos >> br;
        used[pos] = 1;
        ans[pos] = br;
    }
    make_tree(1,1,n);
}
void solve()
{
    for( long long i = 1; i <= v; i ++ )
    {
        long long nb = tree[1];
        //cout << nb << endl;
        update(1,1,n,nb);

        long long tw1 = nb;
        long long tw2 = nb + 1;
        if( nb == n ) tw2 = 1;

        if( used[tw1] == 1 )
        {
            update(1,1,n,tw2);
            ans[tw2] += 1;
        }
        else if( used[tw2] == 1 )
        {
            long long t_wall = tw1 - 1;
            if( tw1 == 1 ) t_wall = n;
            update(1,1,n,t_wall);
        }
        else
        {
            long long prev = tw1 - 1;
            if( tw1 == 1 ) prev = n;
            long long next = tw2;

            if( wall[prev] < wall[next] )
            {
                update(1,1,n,prev);
                ans[tw1] += 1;
                //cout << tree[1] << " " << 111 << endl;
                //cout << endl;
                continue;
            }
            else
            {
                update(1,1,n,next);
                ans[tw2] += 1;
                //cout << tree[1] << " " << 222 << endl;
                //cout << endl;
                continue;
            }
        }
    }
    for( long long i = 1; i <= n; i ++ )
        cout << ans[i] << " ";
    cout << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    solve();
    return 0;
}
