#include<bits/stdc++.h>
using namespace std;
const long long maxn  = 1000000;
long long n,s,h,k;
long long a[maxn];
long long used[maxn];
long long tree[maxn];
long long lazy[maxn*4];
long long ans = 0;
long long maxa = 0;
void make_tree( long long i, long long l, long long r )
{
    if( l == r )
    {
        tree[i] = h;
        return;
    }
    long long m = ( l + r ) / 2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
}
void push_lazy( long long i, long long l, long long r )
{
    if( l == r )
    {
        tree[i] -= lazy[i];
        if( tree[i] < 0 ) tree[i] = 0;
        lazy[i] = 0;
    }
    else
    {
        lazy[i*2] += lazy[i];
        lazy[i*2+1] += lazy[i];
        lazy[i] = 0;
    }
}
void update( long long i, long long l, long long r, long long ql, long long qr, long long x )
{
    push_lazy(i,l,r);
    if( l == ql && r == qr )
    {
        lazy[i] += x;
        push_lazy(i,l,r);
        return;
    }
    long long m = ( l + r ) / 2;
    if( qr <= m ) update(i*2,l,m,ql,qr,x);
    else if( ql > m ) update(i*2+1,m+1,r,ql,qr,x);
    else
    {
        update(i*2,l,m,ql,m,x);
        update(i*2+1,m+1,r,m+1,qr,x);
    }
}
long long query( long long i, long long l, long long r, long long pos )
{
    push_lazy(i,l,r);
    if( l == r ) return tree[i];
    long long m = ( l + r ) /2;
    if( pos <= m ) return query(i*2,l,m,pos);
    else return query(i*2+1,m+1,r,pos);
}
void read()
{
    cin >> n >> s >> h >> k;
    make_tree(1,1,s);
    for( long long i = 1; i <= n; i ++ )
    {
        long long l,r,x;
        cin >> l >> r >> x;
        update(1,1,s,l,r,x);
    }
    for( long long i = 1; i <= s; i ++ )
    {
        a[i] = query(1,1,s,i);
        maxa = max( a[i],maxa);
    }
}
void solve()
{
    for( long long i = 1; i <= s; i ++ )
    {
        long long add = h - a[i];
        ans += add;
    }
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    solve();
    return 0;
}
