#include<bits/stdc++.h>
#pragma optimize ("Ofast")
#define endl '\n'

using namespace std;

const int maxn = 1e5+2, mod = 998244353;
long long n, pos[maxn], dp[maxn], ps[maxn], t[4*maxn];
pair <int, int> a[maxn];

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n ;
    int i;
    for (i=1; i<=n; ++i)
    {
        cin >> a[i].first ;
        a[i].second = i;
    }
}

void init()
{
    sort(a+1, a+n+1);
    int i;
    for (i=1; i<=n; ++i)
    {
        pos[a[i].second] = i;
    }
}

void update(int i, int l, int r, int&idx, long long&val)
{
    if (l == r)
    {
        t[i] += val;
        t[i] %= mod;
        return;
    }
    int mid = (l+r)>>1;
    if (idx <= mid) update(2*i, l, mid, idx, val);
    else update(2*i+1, mid+1, r, idx, val);
    t[i] = t[2*i]+t[2*i+1];
    t[i] %= mod;
}

long long query(int i, int l, int r, int ql, int qr)
{
    if (l==ql && r==qr) return t[i];
    int mid = (l+r)>>1;
    if (ql > mid) return query(2*i+1, mid+1, r, ql, qr);
    if (qr <= mid) return query(2*i, l, mid, ql, qr);
    return ((query(2*i, l, mid, ql, mid) + query(2*i+1, mid+1, r, mid+1, qr))%mod);
}

void solve()
{
    int i, j, idx;
    long long ans = 0, val;
    for (i=n; i>=1; --i)
    {
        idx = pos[i];
        //cout << idx << endl;
        dp[idx] = 1;
        dp[idx] += query(1, 1, n, idx, n);
        dp[idx] %= mod;
        val = dp[idx];
        update(1, 1, n, idx, val);

        //cout << dp[idx] << " " << query(1, 1, n, 1, n) << endl;
        ans += dp[idx];
        ans %= mod;
    }
    cout << ans << endl;
}

int main()
{
    read();
    init();
    solve();
    return 0;
}