#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 1e5+2;
int n, m, q, fup[maxn], tin[maxn], timer, start = 1, in[maxn], out[maxn];
bool used[maxn];
vector <int> v[maxn];
unordered_set <int> points;
unordered_map <int , unordered_set<int>> bridges;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    int i, x, y;
    for (i=1; i<=m; ++i)
    {
        cin >> x >> y ;
        v[x].push_back(y);
        v[y].push_back(x);
    }
}

void cut_bridges(int i, int p)
{
    used[i] = true;
    tin[i] = ++timer;
    fup[i] = timer;
    int j, to, len = (int)(v[i].size());
    for (j=0; j<len; ++j)
    {
        to = v[i][j];
        if (to != p)
        {
            if (used[to])
            {
                if (fup[i] > tin[to]) fup[i] = tin[to];
            }
            else
            {
                cut_bridges(to, i);
                if (fup[i] > fup[to]) fup[i] = fup[to];
                if (tin[i] < fup[to])
                {
                    bridges[i].insert(to);
                    bridges[to].insert(i);
                }
            }
        }
    }
}

void cut_points(int i, int p)
{
    used[i] = true;
    tin[i] = ++timer;
    fup[i] = timer;
    int j, to, len = (int)(v[i].size()), ch = 0;
    for (j=0; j<len; ++j)
    {
        //++ch;
        to = v[i][j];
        if (to != p)
        {
            if (used[to])
            {
                if (fup[i] > tin[to]) fup[i] = tin[to];
            }
            else
            {
                cut_points(to, i);
                if (fup[i] > fup[to]) fup[i] = fup[to];
                if (tin[i] <= fup[to])
                {
                    if (i != start)
                    {
                        if (points.find(i) == points.end()) points.insert(i);
                    }
                    ++ ch;
                }
            }
        }
    }
    if (i == start)
    {
        if (ch >= 2) points.insert(i);
    }
}

void DFS(int s)
{
    used[s] = true;
    in[s] = ++timer;
    int i, len = (int)(v[s].size());
    for (i=0; i<len; ++i)
    {
        if (!used[v[s][i]]) DFS(v[s][i]);
    }
    out[s] = ++timer;
}

void solve()
{
    cut_bridges(1, 0);
    timer = 0;
    memset(used, 0, sizeof(used));
    memset(fup, 0, sizeof(fup));
    memset(tin, 0, sizeof(tin));
    cut_points(1, 0);
    timer = 0;
    memset(used, 0, sizeof(used));
    DFS(1);

    /*map<pair<int, int>, bool> :: iterator  i;
    for (i=bridges.begin(); i!=bridges.end(); ++i)
    {
        cout << ((*i).first).first << " " << ((*i).first).second << endl;
    }
    unordered_set<int> :: iterator it;
    for (it=points.begin(); it!=points.end(); ++it)
    {
        cout << (*it) << endl;
    }
    for (int i=1; i<=n; ++i)
    {
        cout << i << " " << in[i] << " " << out[i] << endl;
    }*/
}

void print()
{
    cin >> q ;
    int i, type, x, y, v, u;
    for (i=1; i<=q; ++i)
    {
        cin >> type >> x >> y >> v ;
        if (type == 1)
        {
            cin >> u ;
            if (bridges[u].find(v) != bridges[u].end())
            {
                if ((in[x]>=in[v] && out[x]<=out[v] && (!(in[y]>=in[v] && out[y]<=out[v]))) ||
                    (in[x]>=in[u] && out[x]<=out[u] && (!(in[y]>=in[u] && out[y]<=out[u]))) ||
                    (in[y]>=in[v] && out[y]<=out[v] && (!(in[x]>=in[v] && out[x]<=out[v]))) ||
                    (in[y]>=in[u] && out[y]<=out[u] && (!(in[x]>=in[u] && out[x]<=out[u]))))
                {
                    cout << "no" << endl;
                }
                else cout << "yes" << endl;


                /*if ((in[x]>=in[u] && in[x]<=out[u] && in[y]>=in[v] && in[y]<=out[v]) ||
                    (in[x]>=in[v] && in[x]<=out[v] && in[y]>=in[u] && in[y]<=out[u]))
                {
                    cout << "no" << endl;
                }
                else cout << "yes" << endl;*/
            }
            else cout << "yes" << endl;


        }
        else
        {
            if (points.find(v) != points.end())
            {
                /*if (in[x]>in[v] && out[x]<out[v] && in[y]>in[v] && out[y]<out[v])
                {
                    if ((in[x]>in[y] && out[x]<out[y]) || (in[y]>in[x] && out[y]<out[x])) cout << "yes" << endl;
                    else cout << "no" << endl;
                }
                else if ((!(in[x]>in[v] && out[x]<out[v])) && (!(in[y]>in[v] && out[y]<out[v])))
                {
                    if ((in[x]>in[y] && out[x]<out[y]) || (in[y]>in[x] && out[y]<out[x])) cout << "yes" << endl;
                    else cout << "no" << endl;
                }
                else cout << "no" << endl;

                if ((in[x]<in[v] && in[y]<in[v]) || (in[x]>in[v] && in[y]>in[v])) cout << "yes" << endl;
                else cout << "no" << endl;*/
                    cout << "no" << endl;
            }
            else cout << "yes" << endl;
        }
    }
}

int main()
{
    read();
    solve();
    print();
    return 0;
}