#include <bits/stdc++.h>
using namespace std;
int n, m;
int timer;
vector<vector<int> > adj;
vector<bool> visited;
vector<int> tin, low;
int children;
bool bridge[10001][10001];
bool point[100001];
void dfs(int v, int p =-1)
{
    visited[v] = 1;
    tin[v] = low[v] = timer++;
    children = 0;
    for(int to: adj[v])
    {
        if(to==p) continue;
        if(visited[to]) low[v] = min(low[v], tin[to]);
        else
        {
            dfs(to, v);
            low[v] = min(low[v], low[to]);
            if(low[to]>tin[v])
            {
                children++;
                bridge[to][v] = bridge[v][to] = 1;
                if(low[to]>=tin[v]&&p!=-1) point[v] = 1;
            }
            if(children>1&&p==-1) point[v] = 1;
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    int a, b;
    for(int i=0; i<m; i++)
    {
        cin>>a>>b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    dfs(1, -1);
    cout<<bridge[1][2]<<endl;
    return 0;
}
