#include <bits/stdc++.h>
using namespace std;
int n, m;
int timer = 1;
vector<int> adj[10001];
bool visited[10001];
int tin[10001], low[10001];
int children;
bool bridge[1001][1001];
bool point[10001];
int a, b;
void dfs(int v, int p)
{
    visited[v] = 1;
    tin[v] =  timer;
    low[v] =  timer;
    timer++;
    children = 0;
    for(int i=0; i<adj[v].size(); i++)
    {
        int to = adj[v][i];
        if(to==p) continue;
        if(visited[to]) low[v] = min(low[v], tin[to]);
        else
        {
            dfs(to, v);
            low[v] = min(low[v], low[to]);
            if(low[to]>=tin[v]&&p!=-1) point[v] = 1;
            children++;
            if(low[to]>tin[v])
            {

                bridge[to][v] = bridge[v][to] = 1;
            }
        }
    }
    if(children>1&&p==-1) point[v] = 1;
    return;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        cin>>a>>b;
        adj[a].push_back(b);
        adj[b].push_back(a);
    }
    dfs(1, -1);
    int type, x, y, a, b, q;
   cin>>q;

   while(q--)
   {
       cin>>type;
       if(type == 1)
       {
           cin>>x>>y>>a>>b;
           if(bridge[a][b]) cout<<"no"<<endl;
           else cout<<"yes"<<endl;
       }
       else
       {
           cin>>x>>y>>a;
           if(point[a]) cout<<"no"<<endl;
           else cout<<"yes"<<endl;
       }
   }
    return 0;
}
