#include<iostream>
#include<algorithm>
#include<unordered_map>
#define endl '\n'
using namespace std;
long long n,a[100005],p[100005],dp[1000005],t[100005],fenwick[100005];
const long long mod=998244353;
int in;
unordered_map <long long,int> mp;
void update(int ibeg,long long val)
{
    for(int i=ibeg;i<=in;i+=(i & -i))
    {
        fenwick[i]+=val;
        fenwick[i]%=mod;
    }
}
long long sum(int ibeg)
{
    long long s=0;
    for(int i=ibeg;i>=1;i-= (i & -i))
    {
        s+=fenwick[i];
        s%=mod;
    }
    return s;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;

    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        p[i]=a[i];
    }
    sort(p,p+n);

    in=0;
    for(int i=0;i<n;i++)
    {
        if(i==0 || p[i]!=p[i-1])
        {
            in++;
            t[in]=p[i];
            mp[p[i]]=in;

        }
    }

    long long s=0,suma=0;
    int k;
    for(int i=0;i<n;i++)
    {
        s=0;
        k=mp[a[i]];
        s=sum(k);
        update(k,s+1);
        suma=(suma+s+1)%mod;
    }
cout<<suma<<endl;

}

