#include<bits/stdc++.h>
using namespace std;
const int maxn  = 1000000;
int n,s,h,k;
int a[maxn];
int used[maxn];
int tree[maxn];
int lazy[maxn*4];
int ans = 0;
void make_tree( int i, int l, int r )
{
    if( l == r )
    {
        tree[i] = h;
        return;
    }
    int m = ( l + r ) / 2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
}
void push_lazy( int i, int l, int r )
{
    if( l == r )
    {
        tree[i] -= lazy[i];
        tree[i] = max( tree[i] , 0 );
        lazy[i] = 0;
    }
    else
    {
        lazy[i*2] += lazy[i];
        lazy[i*2+1] += lazy[i];
        lazy[i] = 0;
    }
}
void update( int i, int l, int r , int ql, int qr, int x )
{
    push_lazy(i,l,r);
    if( l == ql && r == qr )
    {
        lazy[i] += x;
        push_lazy(i,l,r);
        return;
    }
    int m = ( l + r ) / 2;
    if( qr <= m ) update(i*2,l,m,ql,qr,x);
    else if( ql > m ) update(i*2+1,m+1,r,ql,qr,x);
    else
    {
        update(i*2,l,m,ql,m,x);
        update(i*2+1,m+1,r,m+1,qr,x);
    }
}
int query( int i, int l, int r, int pos )
{
    push_lazy(i,l,r);
    if( l == r ) return tree[i];
    int m = ( l + r ) /2;
    if( pos <= m ) return query(i*2,l,m,pos);
    else return query(i*2+1,m+1,r,pos);
}
void read()
{
    cin >> n >> s >> h >> k;
    make_tree(1,1,s);
    for( int i = 1; i <= n; i ++ )
    {
        int l,r,x;
        cin >> l >> r >> x;
        update(1,1,s,l,r,x);
    }
    for( int i = 1; i <= s; i ++ )
        a[i] = query(1,1,s,i);
}
void solve()
{
    a[s+1] = h + 1;
    for( int i = 0; i <= h; i ++ )
    {
        int from = 1;
        int to = 1;
        for( int j = 1; j <= s + 1; j ++ )
        {
            if( a[j] >= i )
            {
                int dist = to - from + 1;
                if( ( from != j ) && ( to != j ) )
                {
                    int cnt = dist / k;
                    if( dist % k != 0 )  cnt += 1;
                    ans += cnt;
                }
                from = j + 1;
                to = j + 1;
            }
            else to = j;
        }
    }
    cout << ans << endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    solve();
    return 0;
}
